package com.ems.ccint;

import com.eos.foundation.data.DataObjectUtil;
import com.eos.foundation.database.DatabaseExt;
import com.eos.system.annotation.Bizlet;
import commonj.sdo.DataObject;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;

@Bizlet("")
/* loaded from: TransferOcrData.class */
public class TransferOcrData {
    public DataObject transferOcrData(DataObject ocrData) throws Exception {
        DataObject transData = DataObjectUtil.createDataObject("com.sie.ems.yx.yxupload.EmsYxApplyOcr");
        return transData;
    }

    public static HashMap heheConverToOcr(String ocrString, String isMultipleBills) throws Exception {
        HashMap<String, Object> tranResult = new HashMap<>();
        new JSONArray();
        JSONObject allObj = JSONObject.fromObject(ocrString);
        if (!allObj.getString("code").equals("0")) {
            throw new Exception(allObj.getString("msg"));
        }
        JSONArray resultObj = allObj.getJSONArray("data");
        if (resultObj == null || resultObj.size() < 1) {
            return tranResult;
        }
        for (int i = 0; i < resultObj.size(); i++) {
            JSONObject obj = resultObj.getJSONObject(i);
            String invoiceTypeCode = obj.getString("invoiceTypeCode");
            if ("301".equals(invoiceTypeCode)) {
                String trainNumber = obj.getString("trainNumber");
                String invoiceDate = obj.getString("invoiceDate");
                String invoiceCode = obj.optString("invoiceCode", "");
                if (StringUtils.isNotBlank(trainNumber)) {
                    obj.put("invoiceCode", trainNumber);
                } else if (StringUtils.isNotBlank(invoiceDate)) {
                    obj.put("invoiceCode", String.valueOf(invoiceCode) + "_" + invoiceDate);
                }
            }
            if ("302".equals(invoiceTypeCode)) {
                BigDecimal taxRate = new BigDecimal(obj.getString("taxRate"));
                BigDecimal totalAmount = new BigDecimal(obj.getString("attribute1"));
                BigDecimal tax = new BigDecimal("1");
                BigDecimal newtaxRate = tax.add(taxRate.setScale(2, 4));
                BigDecimal taxAmountnow = totalAmount.divide(newtaxRate, 2, 4);
                BigDecimal taxAmount = taxAmountnow.multiply(taxRate).setScale(2, 4);
                BigDecimal Amount = totalAmount.subtract(taxAmount).setScale(2, 4);
                obj.put("totalAmount", totalAmount);
                obj.put("taxAmount", taxAmount);
                obj.put("amount", Amount);
                resultObj.remove(i);
                resultObj.add(obj);
            }
        }
        System.out.println(resultObj.toString());
        String str = resultObj.toString().replaceAll("null", "\"\"");
        tranResult.put("response", JSONArray.fromObject(str));
        tranResult.put("flag", "T");
        tranResult.put("message", "识别成功");
        System.out.println(tranResult);
        return tranResult;
    }

    private static HashMap heheConverToOcrOne(JSONObject resultObj, HashMap<String, Object> tranResult) throws Exception {
        JSONArray dataList = resultObj.getJSONArray("item_list");
        JSONObject jsonObject = converToOcr(dataList, resultObj);
        JSONArray tranArr = new JSONArray();
        tranArr.add(jsonObject);
        tranResult.put("response", tranArr);
        tranResult.put("flag", "T");
        tranResult.put("message", "识别成功");
        return tranResult;
    }

    private static HashMap heheConverToOcrMore(JSONObject resultObj, HashMap<String, Object> tranResult) throws Exception {
        JSONArray dataList = resultObj.getJSONArray("object_list");
        JSONArray tranArr = new JSONArray();
        for (int z = 0; z < dataList.size(); z++) {
            JSONObject ocrData = dataList.getJSONObject(z);
            JSONArray values = ocrData.getJSONArray("item_list");
            JSONObject jsonObject = converToOcr(values, ocrData);
            tranArr.add(jsonObject);
        }
        tranResult.put("response", tranArr);
        tranResult.put("flag", "T");
        tranResult.put("message", "识别成功");
        return tranResult;
    }

    private static JSONObject converToOcr(JSONArray map, JSONObject ocrData) throws Exception {
        String taxAmountString;
        JSONObject transData = new JSONObject();
        String[] amountKey = {"收费金额", "金额(小写)", "金额明细", "价税合计小写", "价格", "金额", "项目金额明细", "打印合计"};
        String[] timeKey = {"开票日期", "乘车时间", "填开日期", "收费日期", "日期"};
        String[] invoiceCodeKey = {"发票代码", "红色编码", "电子客票号码", "车辆通行费代码", "代码"};
        String[] invoiceNumberKey = {"发票号码", "红色编码", "电子客票号码", "车辆通行费号码", "号码"};
        String[] taxRateKey = {"税率"};
        String[] totalSumKey = {"价税合计小写"};
        String[] taxAmount = {"税额合计", "税额"};
        String[] chickeCodekeyStrings = {"校验码"};
        String amountString = "";
        String timeString = "";
        String invoiceCodeString = "";
        String invoiceNumberString = "";
        String taxRateString = "";
        String totalSumString = "";
        String taxAmountString2 = "";
        String chickeCode = "";
        for (String key : amountKey) {
            int i = 0;
            while (true) {
                if (i >= map.size()) {
                    break;
                }
                JSONObject obj = (JSONObject) map.get(i);
                String description = obj.get("description").toString();
                if (description.indexOf(key) == -1 || amountString != "") {
                    i++;
                } else {
                    amountString = obj.get("value").toString();
                    break;
                }
            }
        }
        for (String key2 : timeKey) {
            int i2 = 0;
            while (true) {
                if (i2 >= map.size()) {
                    break;
                }
                JSONObject obj2 = (JSONObject) map.get(i2);
                String description2 = obj2.get("description").toString();
                if (description2.indexOf(key2) == -1 || timeString != "") {
                    i2++;
                } else {
                    timeString = obj2.get("value").toString();
                    break;
                }
            }
        }
        if (!"".equals(timeString)) {
            try {
                timeString = timeString.replace("年", "-").replace("月", "-").replace("日", "").substring(0, 10);
            } catch (Exception e) {
                timeString = "";
            }
        }
        for (String key3 : invoiceCodeKey) {
            int i3 = 0;
            while (true) {
                if (i3 >= map.size()) {
                    break;
                }
                JSONObject obj3 = (JSONObject) map.get(i3);
                String description3 = obj3.get("description").toString();
                if (description3.indexOf(key3) == -1 || invoiceCodeString != "") {
                    i3++;
                } else {
                    invoiceCodeString = obj3.get("value").toString();
                    break;
                }
            }
        }
        for (String key4 : invoiceNumberKey) {
            int i4 = 0;
            while (true) {
                if (i4 >= map.size()) {
                    break;
                }
                JSONObject obj4 = (JSONObject) map.get(i4);
                String description4 = obj4.get("description").toString();
                if (description4.indexOf(key4) == -1 || invoiceNumberString != "") {
                    i4++;
                } else {
                    invoiceNumberString = obj4.get("value").toString();
                    break;
                }
            }
        }
        for (String key5 : taxRateKey) {
            int i5 = 0;
            while (true) {
                if (i5 >= map.size()) {
                    break;
                }
                JSONObject obj5 = (JSONObject) map.get(i5);
                String description5 = obj5.get("description").toString();
                if (description5.indexOf(key5) == -1 || taxRateString != "") {
                    i5++;
                } else {
                    taxRateString = obj5.get("value").toString();
                    break;
                }
            }
        }
        for (String key6 : chickeCodekeyStrings) {
            int i6 = 0;
            while (true) {
                if (i6 >= map.size()) {
                    break;
                }
                JSONObject obj6 = (JSONObject) map.get(i6);
                String description6 = obj6.get("description").toString();
                if (description6.indexOf(key6) == -1 || chickeCode != "") {
                    i6++;
                } else {
                    chickeCode = obj6.get("value").toString();
                    break;
                }
            }
        }
        if (!"".equals(taxRateString)) {
            int length = taxRateString.replaceAll("\\s*|\t|\r|\n", "").indexOf("%");
            if (length > 0) {
                Double taxRateT = Double.valueOf(0.01d * Float.parseFloat(r0.substring(0, length)));
                transData.put("taxRate", taxRateT);
            } else {
                transData.put("taxRate", 0);
            }
        }
        for (String key7 : totalSumKey) {
            int i7 = 0;
            while (true) {
                if (i7 >= map.size()) {
                    break;
                }
                JSONObject obj7 = (JSONObject) map.get(i7);
                String description7 = obj7.get("description").toString();
                if (description7.indexOf(key7) == -1 || totalSumString != "") {
                    i7++;
                } else {
                    totalSumString = obj7.get("value").toString();
                    break;
                }
            }
        }
        for (String key8 : taxAmount) {
            int i8 = 0;
            while (true) {
                if (i8 >= map.size()) {
                    break;
                }
                JSONObject obj8 = (JSONObject) map.get(i8);
                String description8 = obj8.get("description").toString();
                if (description8.indexOf(key8) == -1 || taxAmountString2 != "") {
                    i8++;
                } else {
                    taxAmountString2 = obj8.get("value").toString();
                    break;
                }
            }
        }
        if (NumberUtils.isNumber(taxAmountString2.trim())) {
            taxAmountString = taxAmountString2.trim();
        } else {
            taxAmountString = "0";
        }
        for (int i9 = 0; i9 < map.size(); i9++) {
            JSONObject obj9 = (JSONObject) map.get(i9);
            obj9.get("key").toString();
            String description9 = obj9.get("description").toString();
            if (description9.indexOf("销方纳税人识别号") > -1 && !transData.has("sellerTaxNo")) {
                transData.put("sellerTaxNo", obj9.get("value"));
            } else if (description9.indexOf("销售方纳税人识别号") > -1 && !transData.has("sellerTaxNo")) {
                transData.put("sellerTaxNo", obj9.get("value"));
            } else if (description9.indexOf("销方名称") > -1 && !transData.has("sellerName")) {
                transData.put("sellerName", obj9.get("value"));
            } else if (description9.indexOf("销售方名称") > -1 && !transData.has("sellerName")) {
                transData.put("sellerName", obj9.get("value"));
            } else if (description9.indexOf("填开单位") > -1 && !transData.has("sellerName")) {
                transData.put("sellerName", obj9.get("value"));
            } else if (description9.indexOf("销售方地址、电话") > -1 && !transData.has("sellerAddressPhone")) {
                transData.put("sellerAddressPhone", obj9.get("value"));
            } else if (description9.indexOf("销售方开户行及帐号") > -1 && !transData.has("sellerBankAccount")) {
                transData.put("sellerBankAccount", obj9.get("value"));
            } else if (description9.indexOf("购方纳税人识别号") > -1 && !transData.has("buyerTaxNo")) {
                transData.put("buyerTaxNo", obj9.get("value"));
            } else if (description9.indexOf("购方名称") > -1 && !transData.has("buyerName")) {
                transData.put("buyerName", obj9.get("value"));
            } else if (description9.indexOf("购买方名称") > -1 && !transData.has("buyerName")) {
                transData.put("buyerName", obj9.get("value"));
            } else if (description9.indexOf("购买方地址、电话") > -1 && !transData.has("buyerAddressPhone")) {
                transData.put("buyerAddressPhone", obj9.get("value"));
            } else if (description9.indexOf("购买方开户行及帐号") > -1 && !transData.has("buyerBankAccount")) {
                transData.put("buyerBankAccount", obj9.get("value"));
            } else if (description9.indexOf("校验码") > -1 && !transData.has("invoiceCheckCode")) {
                transData.put("invoiceCheckCode", obj9.get("value"));
            } else if (description9.indexOf("乘客名称") > -1 && !transData.has("operatorName")) {
                transData.put("operatorName", obj9.get("value"));
            } else if (description9.indexOf("购买方纳税人识别号") > -1 && !transData.has("buyerTaxNo")) {
                transData.put("buyerTaxNo", obj9.get("value"));
            }
        }
        transData.put("emsYxApplyOcrLists", getOcrList(map));
        String amountString2 = amountString.replaceAll("\t|\r|\n", "|");
        if (!StringUtils.isBlank(amountString2) && amountString2.indexOf("|") > -1) {
            String[] strs = amountString2.split("\\|");
            float tempAmount = 0.0f;
            for (String str : strs) {
                if (!StringUtils.isBlank(str)) {
                    tempAmount += Float.parseFloat(str);
                }
            }
            transData.put("amount", Float.valueOf(tempAmount));
        } else if (!StringUtils.isBlank(amountString2)) {
            try {
                transData.put("amount", Float.valueOf(Float.parseFloat(amountString2.trim())));
            } catch (Exception e2) {
                transData.put("amount", 0);
            }
        } else {
            transData.put("amount", 0);
        }
        if (!StringUtils.isBlank(timeString)) {
            transData.put("invoiceDate", timeString);
        }
        if (StringUtils.isBlank(invoiceNumberString) && !StringUtils.isBlank(invoiceCodeString)) {
            invoiceNumberString = invoiceCodeString;
        } else if (StringUtils.isBlank(invoiceNumberString) && StringUtils.isBlank(invoiceCodeString)) {
            int radoms = (int) ((Math.random() * 900.0d) + 100.0d);
            invoiceNumberString = "A_" + System.currentTimeMillis() + "_" + radoms;
            invoiceCodeString = invoiceNumberString;
        }
        transData.put("invoiceCode", invoiceCodeString);
        transData.put("invoiceNo", invoiceNumberString);
        try {
            Double.valueOf(totalSumString.trim()).doubleValue();
            transData.put("totalAmount", totalSumString.trim());
        } catch (Exception e3) {
            transData.put("totalAmount", 0);
        }
        if (StringUtils.isBlank(totalSumString) && !StringUtils.isBlank(amountString2)) {
            try {
                Double.valueOf(amountString2.trim()).doubleValue();
                transData.put("totalAmount", amountString2.trim());
            } catch (Exception e4) {
                transData.put("totalAmount", 0);
            }
        }
        transData.put("chickeCode", chickeCode);
        try {
            Double.valueOf(taxAmountString.trim()).doubleValue();
            transData.put("taxAmount", taxAmountString.trim());
        } catch (Exception e5) {
            transData.put("taxAmount", 0);
        }
        transData.put("imageApplyHId", "");
        transData.put("imageLId", "");
        transData.put("sourceSystem", "EMS_YX");
        transData.put("sourceOrderType", "YX_OCR");
        String invinfo = (String) ocrData.get("type_description");
        transData.put("invoiceType", invinfo);
        if (invinfo.equals("增值税专用发票")) {
            transData.put("invoiceTypeCode", "004");
        } else if (invinfo.equals("机动车销售统一发票")) {
            transData.put("invoiceTypeCode", "005");
        } else if (invinfo.equals("增值税普通发票")) {
            transData.put("invoiceTypeCode", "007");
        } else if (invinfo.equals("增值税电子发票")) {
            transData.put("invoiceTypeCode", "026");
        } else if (invinfo.equals("增值税卷式发票")) {
            transData.put("invoiceTypeCode", "025");
        } else if (invinfo.equals("增值税普通发票")) {
            transData.put("invoiceTypeCode", "101");
        } else if (invinfo.equals("增值税电子普通发票")) {
            transData.put("invoiceTypeCode", "102");
        } else if (invinfo.equals("增值税电子普通发票(通行费)")) {
            transData.put("invoiceTypeCode", "103");
        } else if (invinfo.equals("机动车销售统一发票")) {
            transData.put("invoiceTypeCode", "200");
        } else if (invinfo.equals("二手车销售统一发票")) {
            transData.put("invoiceTypeCode", "201");
        } else if (invinfo.equals("增值税普通发票（卷票)")) {
            transData.put("invoiceTypeCode", "300");
        } else if (invinfo.indexOf("火车票") > -1) {
            transData.put("invoiceTypeCode", "301");
        } else if (invinfo.equals("飞机行程单")) {
            transData.put("invoiceTypeCode", "302");
        } else if (invinfo.indexOf("飞机票") > -1) {
            transData.put("invoiceTypeCode", "302");
        } else if (invinfo.indexOf("行程单") > -1) {
            transData.put("invoiceTypeCode", "302");
        } else if (invinfo.indexOf("出租车") > -1) {
            transData.put("invoiceTypeCode", "303");
        } else if (invinfo.equals("公路客运发票")) {
            transData.put("invoiceTypeCode", "304");
        } else if (invinfo.indexOf("客运汽车") > -1) {
            transData.put("invoiceTypeCode", "304");
        } else if (invinfo.indexOf("定额发票") > -1) {
            transData.put("invoiceTypeCode", "305");
        } else if (invinfo.indexOf("过路过桥费发票") > -1) {
            transData.put("invoiceTypeCode", "306");
        } else if (invinfo.indexOf("船运客票") > -1) {
            transData.put("invoiceTypeCode", "307");
        } else {
            transData.put("invoiceTypeCode", "999");
        }
        DecimalFormat df = new DecimalFormat("#.00");
        if ("301".equals(transData.getString("invoiceTypeCode")) || "302".equals(transData.getString("invoiceTypeCode"))) {
            transData.put("taxRate", "0.09");
            double taxAmount1 = Double.parseDouble(df.format((transData.getDouble("totalAmount") / 1.09d) * 0.09d));
            transData.put("taxAmount", Double.valueOf(taxAmount1));
            transData.put("amount", Double.valueOf(transData.getDouble("totalAmount") - taxAmount1));
        } else if ("304".equals(transData.getString("invoiceTypeCode"))) {
            transData.put("taxRate", "0.03");
            String tota = transData.getString("totalAmount");
            if (tota.equals("") || tota.equals(null)) {
                transData.put("totalAmount", 0);
            }
            double taxAmount12 = Double.parseDouble(df.format((transData.getDouble("totalAmount") / 1.03d) * 0.03d));
            transData.put("taxAmount", Double.valueOf(taxAmount12));
            transData.put("amount", Double.valueOf(transData.getDouble("totalAmount") - taxAmount12));
        }
        return transData;
    }

    private static JSONArray getOcrList(JSONArray jsonArray) throws Exception {
        JSONArray ocrList = new JSONArray();
        int length = 0;
        List<String> goods = new ArrayList<>();
        String[] goodList = null;
        String[] plateSpecific = null;
        String[] electransUnit = null;
        String[] quantity = null;
        String[] unitPrice = null;
        String[] priceList = null;
        String[] rateList = null;
        String[] taxList = null;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject data = jsonArray.getJSONObject(i);
            if (data.getString("key").equalsIgnoreCase("vat_invoice_goods_list")) {
                goodList = data.getString("value").split("\\n");
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_plate_specific")) {
                plateSpecific = data.getString("value").split("\\n");
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_electrans_unit")) {
                electransUnit = data.getString("value").split("\\n");
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_electrans_quantity")) {
                quantity = data.getString("value").split("\\n");
                try {
                    Float.parseFloat(quantity[0].toString());
                } catch (Exception e) {
                    quantity = null;
                }
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_electrans_unit_price")) {
                unitPrice = data.getString("value").split("\\n");
                try {
                    Float.parseFloat(unitPrice[0].toString());
                } catch (Exception e2) {
                    unitPrice = null;
                }
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_price_list")) {
                priceList = data.getString("value").split("\\n");
                try {
                    Float.parseFloat(priceList[0].toString());
                } catch (Exception e3) {
                    priceList = null;
                }
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_tax_rate_list")) {
                if (rateList == null) {
                    rateList = data.getString("value").split("\\n");
                } else {
                    String[] rateList1 = data.getString("value").split("\\n");
                    if (rateList.length < rateList1.length) {
                        rateList = data.getString("value").split("\\n");
                    }
                }
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_tax_rate")) {
                rateList = data.getString("value").split("\\n");
            } else if (data.getString("key").equalsIgnoreCase("vat_invoice_tax_list")) {
                taxList = data.getString("value").split("\\n");
            }
        }
        if (goodList != null) {
            length = goodList.length;
            if (length > 1) {
                StringBuffer buffer = new StringBuffer();
                for (int i2 = length - 1; i2 >= 0; i2--) {
                    if (String.valueOf(goodList[i2].trim()).indexOf("*") == -1) {
                        buffer.insert(0, goodList[i2].trim());
                    } else {
                        if (buffer.length() > 0) {
                            buffer.insert(1, goodList[i2].trim());
                        }
                        if (buffer.length() == 0) {
                            buffer.insert(0, goodList[i2].trim());
                        }
                        System.out.println(buffer.toString());
                        goods.add(buffer.toString());
                        buffer = new StringBuffer();
                    }
                }
                length = goods.size();
            }
        }
        for (int i3 = 0; i3 < length; i3++) {
            JSONObject jsonObject = new JSONObject();
            if (goods.size() > 0) {
                jsonObject.put("goods", goods.get(i3));
            } else {
                jsonObject.put("goods", goodList[i3]);
            }
            if (plateSpecific != null && plateSpecific.length == length) {
                jsonObject.put("models", plateSpecific[i3]);
            }
            if (electransUnit != null && electransUnit.length == length) {
                jsonObject.put("unit", electransUnit[i3]);
            }
            if (quantity != null && quantity.length == length) {
                jsonObject.put("quantity", quantity[i3].trim());
            }
            if (unitPrice != null && unitPrice.length == length) {
                try {
                    Float.parseFloat(unitPrice[i3].trim());
                    jsonObject.put("price", unitPrice[i3].trim());
                } catch (Exception e4) {
                    jsonObject.put("price", 0);
                }
            }
            if (priceList != null && priceList.length == length) {
                jsonObject.put("amount", priceList[i3].trim());
            }
            if (rateList != null && rateList.length == length) {
                String taxRateString = rateList[i3].trim();
                if (!StringUtils.isEmpty(taxRateString)) {
                    if (taxRateString.indexOf("%") > 0) {
                        if (StringUtils.isNumeric(taxRateString.replace("%", ""))) {
                            Double taxRateT = Double.valueOf(0.01d * Float.parseFloat(taxRateString.substring(0, taxRateString.indexOf("%"))));
                            jsonObject.put("taxRate", taxRateT);
                        } else {
                            Double taxRateT2 = Double.valueOf(0.0d);
                            jsonObject.put("taxRate", taxRateT2);
                        }
                    } else {
                        jsonObject.put("taxRate", 0);
                    }
                } else {
                    jsonObject.put("taxRate", taxRateString);
                }
            }
            if (taxList != null && taxList.length == length) {
                if (NumberUtils.isNumber(taxList[i3].trim())) {
                    jsonObject.put("taxAmount", taxList[i3].trim());
                } else {
                    jsonObject.put("taxAmount", 0);
                }
            }
            ocrList.add(jsonObject);
        }
        return ocrList;
    }

    public static HashMap ConverToOcr(String ocrString) throws Exception {
        HashMap<String, Object> tranResult = new HashMap<>();
        JSONArray tranArr = new JSONArray();
        JSONObject allObj = JSONObject.fromObject(ocrString);
        if (!allObj.getString("code").equals("200")) {
            throw new Exception(allObj.getString("message"));
        }
        JSONObject resultObj = allObj.getJSONObject("result");
        if (resultObj == null || resultObj.size() < 1) {
            return tranResult;
        }
        JSONArray dataList = resultObj.getJSONArray("item_list");
        String[] amountKey = {"合计", "金额(小写)", "金额明细", "价税合计小写", "价格", "金额"};
        String[] timeKey = {"开票日期", "乘车时间"};
        String[] invoiceCodeKey = {"发票代码", "红色编码"};
        String[] invoiceNumberKey = {"发票号码", "红色编码"};
        String[] taxRateKey = {"税率"};
        String[] totalSumKey = {"价税合计小写"};
        String[] taxAmount = {"税额合计", "税额"};
        for (int z = 0; z < dataList.size(); z++) {
            JSONObject ocrData = dataList.getJSONObject(z);
            JSONArray map = ocrData.getJSONArray("value");
            JSONObject transData = new JSONObject();
            String amountString = "";
            String timeString = "";
            String invoiceCodeString = "";
            String invoiceNumberString = "";
            String taxRateString = "";
            String totalSumString = "";
            String taxAmountString = "";
            for (String key : amountKey) {
                int i = 0;
                while (true) {
                    if (i >= map.size()) {
                        break;
                    }
                    JSONObject obj = (JSONObject) map.get(i);
                    String description = obj.get("description").toString();
                    if (description.indexOf(key) == -1 || amountString != "") {
                        i++;
                    } else {
                        amountString = obj.get("value").toString();
                        break;
                    }
                }
            }
            for (String key2 : timeKey) {
                int i2 = 0;
                while (true) {
                    if (i2 >= map.size()) {
                        break;
                    }
                    JSONObject obj2 = (JSONObject) map.get(i2);
                    String description2 = obj2.get("description").toString();
                    if (description2.indexOf(key2) == -1 || timeString != "") {
                        i2++;
                    } else {
                        timeString = obj2.get("value").toString();
                        break;
                    }
                }
            }
            if (timeString != "") {
                timeString = timeString.replace("年", "-").replace("月", "-").replace("日", "").substring(0, 10);
            }
            for (String key3 : invoiceCodeKey) {
                int i3 = 0;
                while (true) {
                    if (i3 >= map.size()) {
                        break;
                    }
                    JSONObject obj3 = (JSONObject) map.get(i3);
                    String description3 = obj3.get("description").toString();
                    if (description3.indexOf(key3) == -1 || invoiceCodeString != "") {
                        i3++;
                    } else {
                        invoiceCodeString = obj3.get("value").toString();
                        break;
                    }
                }
            }
            for (String key4 : invoiceNumberKey) {
                int i4 = 0;
                while (true) {
                    if (i4 >= map.size()) {
                        break;
                    }
                    JSONObject obj4 = (JSONObject) map.get(i4);
                    String description4 = obj4.get("description").toString();
                    if (description4.indexOf(key4) == -1 || invoiceNumberString != "") {
                        i4++;
                    } else {
                        invoiceNumberString = obj4.get("value").toString();
                        break;
                    }
                }
            }
            for (String key5 : taxRateKey) {
                int i5 = 0;
                while (true) {
                    if (i5 >= map.size()) {
                        break;
                    }
                    JSONObject obj5 = (JSONObject) map.get(i5);
                    String description5 = obj5.get("description").toString();
                    if (description5.indexOf(key5) == -1 || taxRateString != "") {
                        i5++;
                    } else {
                        taxRateString = obj5.get("value").toString();
                        break;
                    }
                }
            }
            if (taxRateString != "") {
                int length = taxRateString.replaceAll("\\s*|\t|\r|\n", "").indexOf("%");
                if (length > 0) {
                    Double taxRateT = Double.valueOf(0.01d * Float.parseFloat(r0.substring(0, length)));
                    transData.put("taxRate", taxRateT);
                } else {
                    transData.put("taxRate", 0);
                }
            }
            for (String key6 : totalSumKey) {
                int i6 = 0;
                while (true) {
                    if (i6 >= map.size()) {
                        break;
                    }
                    JSONObject obj6 = (JSONObject) map.get(i6);
                    String description6 = obj6.get("description").toString();
                    if (description6.indexOf(key6) == -1 || totalSumString != "") {
                        i6++;
                    } else {
                        totalSumString = obj6.get("value").toString();
                        break;
                    }
                }
            }
            for (String key7 : taxAmount) {
                int i7 = 0;
                while (true) {
                    if (i7 >= map.size()) {
                        break;
                    }
                    JSONObject obj7 = (JSONObject) map.get(i7);
                    String description7 = obj7.get("description").toString();
                    if (description7.indexOf(key7) == -1 || taxAmountString != "") {
                        i7++;
                    } else {
                        taxAmountString = obj7.get("value").toString();
                        break;
                    }
                }
            }
            for (int i8 = 0; i8 < map.size(); i8++) {
                JSONObject obj8 = (JSONObject) map.get(i8);
                obj8.get("key").toString();
                String description8 = obj8.get("description").toString();
                if (description8.indexOf("销方纳税人识别号") > -1 && !transData.has("sellerTaxNo")) {
                    transData.put("sellerTaxNo", obj8.get("value"));
                } else if (description8.indexOf("销售方纳税人识别号") > -1 && !transData.has("sellerTaxNo")) {
                    transData.put("sellerTaxNo", obj8.get("value"));
                } else if (description8.indexOf("销方名称") > -1 && !transData.has("sellerName")) {
                    transData.put("sellerName", obj8.get("value"));
                } else if (description8.indexOf("销售方名称") > -1 && !transData.has("sellerName")) {
                    transData.put("sellerName", obj8.get("value"));
                } else if (description8.indexOf("销售方地址、电话") > -1 && !transData.has("sellerAddressPhone")) {
                    transData.put("sellerAddressPhone", obj8.get("value"));
                } else if (description8.indexOf("销售方开户行及帐号") > -1 && !transData.has("sellerBankAccount")) {
                    transData.put("sellerBankAccount", obj8.get("value"));
                } else if (description8.indexOf("购方纳税人识别号") > -1 && !transData.has("buyerTaxNo")) {
                    transData.put("buyerTaxNo", obj8.get("value"));
                } else if (description8.indexOf("购方名称") > -1 && !transData.has("buyerName")) {
                    transData.put("buyerName", obj8.get("value"));
                } else if (description8.indexOf("购买方名称") > -1 && !transData.has("buyerName")) {
                    transData.put("buyerName", obj8.get("value"));
                } else if (description8.indexOf("购买方地址、电话") > -1 && !transData.has("buyerAddressPhone")) {
                    transData.put("buyerAddressPhone", obj8.get("value"));
                } else if (description8.indexOf("购买方开户行及帐号") > -1 && !transData.has("buyerBankAccount")) {
                    transData.put("buyerBankAccount", obj8.get("value"));
                } else if (description8.indexOf("校验码") > -1 && !transData.has("invoiceCheckCode")) {
                    transData.put("invoiceCheckCode", obj8.get("value"));
                }
            }
            transData.put("amount", amountString);
            if (!StringUtils.isBlank(timeString)) {
                transData.put("invoiceDate", timeString);
            }
            transData.put("invoiceCode", invoiceCodeString);
            transData.put("invoiceNo", invoiceNumberString);
            transData.put("totalAmount", totalSumString);
            if (StringUtils.isBlank(totalSumString) && !StringUtils.isBlank(amountString)) {
                transData.put("totalAmount", amountString);
            }
            transData.put("taxAmount", taxAmountString);
            transData.put("imageApplyHId", "");
            transData.put("imageLId", "");
            transData.put("sourceSystem", "EMS_YX");
            transData.put("sourceOrderType", "YX_OCR");
            String invinfo = (String) ocrData.get("description");
            transData.put("invoiceType", invinfo);
            if (invinfo.equals("增值税专用发票")) {
                transData.put("invoiceTypeCode", 4);
            } else if (invinfo.equals("机动车销售统一发票")) {
                transData.put("invoiceTypeCode", 5);
            } else if (invinfo.equals("增值税普通发票")) {
                transData.put("invoiceTypeCode", 7);
            } else if (invinfo.equals("增值税电子发票")) {
                transData.put("invoiceTypeCode", 22);
            } else if (invinfo.equals("增值税卷式发票")) {
                transData.put("invoiceTypeCode", 21);
            } else if (invinfo.equals("增值税专用发票")) {
                transData.put("invoiceTypeCode", 100);
            } else if (invinfo.equals("增值税普通发票")) {
                transData.put("invoiceTypeCode", 101);
            } else if (invinfo.equals("增值税电子普通发票")) {
                transData.put("invoiceTypeCode", 102);
            } else if (invinfo.equals("机动车销售统一发票")) {
                transData.put("invoiceTypeCode", 200);
            } else if (invinfo.equals("二手车销售统一发票")) {
                transData.put("invoiceTypeCode", 201);
            } else if (invinfo.equals("增值税普通发票（卷票)")) {
                transData.put("invoiceTypeCode", 300);
            } else if (invinfo.indexOf("火车票") > -1) {
                transData.put("invoiceTypeCode", 301);
            } else if (invinfo.indexOf("飞机票") > -1) {
                transData.put("invoiceTypeCode", 302);
            } else if (invinfo.indexOf("出租车") > -1) {
                transData.put("invoiceTypeCode", 303);
            } else if (invinfo.indexOf("客运汽车") > -1) {
                transData.put("invoiceTypeCode", 304);
            } else if (invinfo.indexOf("定额发票") > -1) {
                transData.put("invoiceTypeCode", 305);
            } else {
                transData.put("invoiceTypeCode", 999);
            }
            tranArr.add(transData);
        }
        tranResult.put("response", tranArr);
        tranResult.put("flag", "T");
        tranResult.put("message", "识别成功");
        return tranResult;
    }

    public static String getOcrSystem() throws Exception {
        String ocrSystem;
        HashMap<String, String> ocrSystemParam = new HashMap<>(1);
        ocrSystemParam.put("dicttypeid", "OCR_SYSTEM");
        Object[] ocrSystems = DatabaseExt.queryByNamedSql("default", "com.ems.saas.synchronizationNamingsql.getEosDictEntry", ocrSystemParam);
        if (ocrSystems.length > 0) {
            ocrSystem = ((DataObject) ocrSystems[0]).getString("DICTID").toString();
        } else {
            ocrSystem = "";
            System.out.println("接入ocr系统为:" + ocrSystems);
        }
        return ocrSystem;
    }

    public static String getOcrCheckSystem() throws Exception {
        String ocrSystem;
        HashMap<String, String> ocrSystemParam = new HashMap<>(1);
        ocrSystemParam.put("dicttypeid", "OCR_CHECK_SYSTEM");
        Object[] ocrSystems = DatabaseExt.queryByNamedSql("default", "com.ems.saas.synchronizationNamingsql.getEosDictEntry", ocrSystemParam);
        if (ocrSystems.length > 0) {
            ocrSystem = ((DataObject) ocrSystems[0]).getString("DICTID").toString();
        } else {
            ocrSystem = "";
            System.out.println("接入验真系统为:" + ocrSystems);
        }
        return ocrSystem;
    }

    public static void main(String[] args) throws Exception {
        HashMap tt = heheConverToOcr("{\"cost_time\":5278,\"result\":{\"image_angle\":0,\"type_description\":\"增值税专用发票\",\"rotated_image_width\":4032,\"rotated_image_height\":3024,\"kind\":\"service\",\"class\":\"nation_tax_invoice\",\"item_list\":[{\"value\":\"非电子发票\",\"description\":\"发票类型\",\"position\":[],\"key\":\"vat_invoice_type\"},{\"value\":\"专票\",\"description\":\"专票\\/普票\",\"position\":[],\"key\":\"vat_invoice_zhuan_yong_flag\"},{\"value\":\"110018213001\",\"description\":\"发票代码\",\"position\":[2234,903,2347,903,2347,1608,2234,1608],\"key\":\"vat_invoice_daima\"},{\"value\":\"53895870\",\"description\":\"发票号码\",\"position\":[2103,3024,2161,3024,2161,3024,2103,3024],\"key\":\"vat_invoice_haoma\"},{\"value\":\"110018213001\",\"description\":\"右侧打印发票代码\",\"position\":[2234,903,2347,903,2347,1608,2234,1608],\"key\":\"vat_invoice_daima_print\"},{\"value\":\"\",\"description\":\"校验码\",\"position\":[],\"key\":\"vat_invoice_correct_code\"},{\"value\":\"2019年06月21日\",\"description\":\"开票日期\",\"position\":[2013,3024,2090,3024,2090,3024,2013,3024],\"key\":\"vat_invoice_issue_date\"},{\"value\":\"\",\"description\":\"打印校验码\",\"position\":[],\"key\":\"vat_invoice_corrent_code_print\"},{\"value\":\"发票联\",\"description\":\"标题发票联\",\"position\":[2056,1934,2167,1934,2167,2384,2056,2384],\"key\":\"vat_invoice_headline_page_number\"},{\"value\":\"53895870\",\"description\":\"增值税发票No号码\",\"position\":[2179,2937,2287,2937,2287,3024,2179,3024],\"key\":\"vat_invoice_haoma_large_size\"},{\"value\":\"538958701100\",\"description\":\"右侧打印发票代码\",\"position\":[2175,2937,2287,2937,2287,3024,2175,3024],\"key\":\"vat_invoice_daima_right_side\"},{\"value\":\"53895870\",\"description\":\"右侧打印发票号码\",\"position\":[2103,3024,2161,3024,2161,3024,2103,3024],\"key\":\"vat_invoice_haoma_right_side\"},{\"value\":\"2019年06月21日\",\"description\":\"右侧打印开票日期\",\"position\":[2013,3024,2090,3024,2090,3024,2013,3024],\"key\":\"vat_invoice_issue_date_print\"},{\"value\":\"国科恒泰(北京)医疗科技股份有限公司科份有公\",\"description\":\"购买方名称\",\"position\":[1912,1047,2010,1047,2010,2368,1912,2368],\"key\":\"vat_invoice_payer_name\"},{\"value\":\"91110302062833606R2062833606R\",\"description\":\"购买方纳税人识别号\",\"position\":[1839,1028,1928,1028,1928,2336,1839,2336],\"key\":\"vat_invoice_rate_payer_id\"},{\"value\":\"北京市北京经济技术开发区经海园路25号院6号楼5层501C室 010-67867668-6244\",\"description\":\"购买方地址、电话\",\"position\":[1757,1038,1834,1038,1834,2357,1757,2357],\"key\":\"vat_invoice_payer_addr_tell\"},{\"value\":\"中国银行北京分行营业部325964009845\",\"description\":\"购买方开户行及帐号\",\"position\":[1669,1034,1752,1034,1752,2364,1669,2364],\"key\":\"vat_invoice_payer_bank_account\"},{\"value\":\"0329<-181\\/<>5<*-\\/04+<>68<\\/4*70+14<930<5\\/9+028041670400>210<85<7>7><06\\/4<9784<69-*<>\\/560794-70015-2503\\/6>3\\/52-》-\",\"description\":\"密码区\",\"position\":[1638,2380,1953,2380,1953,3024,1638,3024],\"key\":\"vat_invoice_cipher_field\"},{\"value\":\"*其他咨询服务*咨询费\",\"description\":\"货物或服务名称\",\"position\":[1542,616,1613,616,1613,1351,1542,1351],\"key\":\"vat_invoice_goods_list\"},{\"value\":\"\",\"description\":\"规格型号明细\",\"position\":[],\"key\":\"vat_invoice_plate_specific\"},{\"value\":\"\",\"description\":\"单位明细\",\"position\":[],\"key\":\"vat_invoice_electrans_unit\"},{\"value\":\"\",\"description\":\"数量明细\",\"position\":[],\"key\":\"vat_invoice_electrans_quantity\"},{\"value\":\"\",\"description\":\"单价明细\",\"position\":[],\"key\":\"vat_invoice_electrans_unit_price\"},{\"value\":\"84905.66\",\"description\":\"金额明细\",\"position\":[1491,2806,1542,2806,1542,3024,1491,3024],\"key\":\"vat_invoice_price_list\"},{\"value\":\"6%\",\"description\":\"税率明细\",\"position\":[1491,3024,1535,3024,1535,3024,1491,3024],\"key\":\"vat_invoice_tax_rate_list\"},{\"value\":\"5094.34\",\"description\":\"税额明细\",\"position\":[1471,3024,1521,3024,1521,3024,1471,3024],\"key\":\"vat_invoice_tax_list\"},{\"value\":\"发票联\",\"description\":\"抵扣联\\/发票联\",\"position\":[813,3024,1614,3024,1614,3024,813,3024],\"key\":\"vat_invoice_page_number\"},{\"value\":\"84905.66\",\"description\":\"合计\",\"position\":[930,2661,998,2661,998,3024,930,3024],\"key\":\"vat_invoice_total\"},{\"value\":\"6%\",\"description\":\"税率\",\"position\":[1491,3024,1535,3024,1535,3024,1491,3024],\"key\":\"vat_invoice_tax_rate\"},{\"value\":\"84905.66\",\"description\":\"打印合计\",\"position\":[930,2661,998,2661,998,3024,930,3024],\"key\":\"vat_invoice_total_print\"},{\"value\":\"5094.34\",\"description\":\"税额合计\",\"position\":[912,3024,979,3024,979,3024,912,3024],\"key\":\"vat_invoice_tax_total\"},{\"value\":\"玖万圆整\",\"description\":\"价税合计大写\",\"position\":[867,1478,918,1478,918,1666,867,1666],\"key\":\"vat_invoice_total_cover_tax\"},{\"value\":\"90000.00\",\"description\":\"价税合计小写\",\"position\":[],\"key\":\"vat_invoice_total_cover_tax_digits\"},{\"value\":\"中天华薄管理咨询(北京)有限公司(北京)公\",\"description\":\"销售方名称\",\"position\":[735,1000,830,1000,830,2226,735,2226],\"key\":\"vat_invoice_seller_name\"},{\"value\":\"91110108053584337M805353\",\"description\":\"销售方纳税人识别号\",\"position\":[645,1035,738,1035,738,2193,645,2193],\"key\":\"vat_invoice_seller_id\"},{\"value\":\"北京市海淀区双清路77号院2号楼2层204号18610761921\",\"description\":\"销售方地址、电话\",\"position\":[561,997,653,997,653,2323,561,2323],\"key\":\"vat_invoice_seller_addr_tell\"},{\"value\":\"中国建设银行北京西四支行11001007200059261884\",\"description\":\"销售方开户行及帐号\",\"position\":[492,991,612,991,612,2139,492,2139],\"key\":\"vat_invoice_seller_bank_account\"},{\"value\":\"\",\"description\":\"备注\",\"position\":[],\"key\":\"vat_invoice_total_note\"},{\"value\":\"\",\"description\":\"备注校验码\",\"position\":[],\"key\":\"vat_invoice_note_correct_code\"},{\"value\":\"\",\"description\":\"收款人\",\"position\":[],\"key\":\"vat_invoice_payee\"},{\"value\":\"\",\"description\":\"复核\",\"position\":[],\"key\":\"vat_invoice_review\"},{\"value\":\"管理员\",\"description\":\"开票人\",\"position\":[396,2118,484,2118,484,2536,396,2536],\"key\":\"vat_invoice_drawer\"},{\"value\":\"True\",\"description\":\"盖章存在性判断\",\"position\":[],\"key\":\"exist_stample\"},{\"value\":\"否\",\"description\":\"代开(非代开条目为空)\",\"position\":[],\"key\":\"vat_invoice_dai_kai_flag\"},{\"value\":\"\",\"description\":\"机打号码\",\"position\":[],\"key\":\"vat_invoice_jida_haoma\"}],\"kind_description\":\"服务\",\"type\":\"vat_special_invoice\"},\"code\":200,\"message\":\"success\"}", "N");
        System.out.print(tt);
    }
}
